VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMSOffice"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

Private oWord As Word.Application
Private oDoc As Word.Document
Private oExcel As Excel.Application
Private oWorkbook As New Excel.Workbook


Public Sub openWordApplication()
        Set oWord = New Word.Application
End Sub


Public Function createWordFile(strURI As String) As String
 
    On Error GoTo err_Handler
    
    'check if Word is already existent
    If oWord Is Nothing Then
        openWordApplication
    End If
    
    Set oDoc = oWord.Documents.Add
    
    oDoc.SaveAs strURI
    
    createWordFile = ""

'error handling
Exit Function
err_Handler:

    createWordFile = "Error CreateWordFile(): " & Err.Description
    oDoc.Close False
    oWord.Quit
    
End Function


Public Function openWordFile(strURI As String) As String
    Dim i
    
    On Error GoTo err_Handler
    

    If oWord Is Nothing Then
        openWordApplication
    End If

        
    'Opening the Word file
    oWord.Documents.Open strURI
    
   'selecting the doc
    For i = 1 To oWord.Documents.count
        If oWord.Documents.Item(i).FullName = strURI Then
            Set oDoc = oWord.Documents(i)
        Else
            Err.Raise 23, , "File not found"
        End If
    Next
        
    oWord.Visible = False
    
    openWordFile = ""
    
    
'error handling
Exit Function
err_Handler:

    openWordFile = "Error openWordFile(): " & Err.Description
    
End Function


Public Sub saveWordFile()

    If Not oDoc Is Nothing Then
        'close the file
        oWord.ActiveDocument.Save
        Call oDoc.Save
    End If
        oWord.ActiveDocument.Save
End Sub


Public Function saveWordFileAs(strURI As String) As String
    If Not oDoc Is Nothing Then
        'close the file
        Call oDoc.SaveAs(strURI)
    End If
End Function


Public Function closeWordFile()
    If Not oDoc Is Nothing Then
        'close the file
        oWord.ActiveDocument.Close True
    End If
        oWord.Quit
        Set oDoc = Nothing
        Set oWord = Nothing
    
End Function


Public Sub openExcelApplication()

        Set oExcel = New Excel.Application

End Sub


Public Function createExcelFile(strURI As String) As String
 
    On Error GoTo err_Handler
    
    'check if Excel is already existent
    If oExcel Is Nothing Then
        openExcelApplication
    End If
    
    Set oWorkbook = oExcel.Workbooks.Add()
    
    oWorkbook.SaveAs strURI
    
    createExcelFile = ""

'error handling
Exit Function
err_Handler:

    createExcelFile = "Error createExcelFile(): " & Err.Description
    oWorkbook.Close False
    oExcel.Quit
    
    
End Function


Public Function openExcelFile(strURI As String) As String
    Dim i
    
    On Error GoTo err_Handler
    
   ' If Not oWorkbook Is Nothing Then
   '     Set oWorkbook = Nothing
   ' End If
    'check if Excel is already existent
    If oExcel Is Nothing Then
        openExcelApplication
    End If

        
    'Opening the Excel file
    oExcel.Workbooks.Open strURI
    
    'selcting the workbook
    For i = 1 To oExcel.Workbooks.count
        If oExcel.Workbooks.Item(i).FullName = strURI Then
            Set oWorkbook = oExcel.Workbooks(i)
        Else
            Err.Raise 23, , "CRS workbook was not found"
        End If
    Next
        
    
    openExcelFile = ""
    
    
'error handling
Exit Function
err_Handler:

    openExcelFile = "Error openExcelFile(): " & Err.Description
    
End Function


Public Sub saveExcelFile()
    If Not oWorkbook Is Nothing Then
        'close the file
        Call oWorkbook.Save
    End If
    oWorkbook.Save
End Sub

Public Sub closeExcelFile()

    If Not oWorkbook Is Nothing Then
        'close the file
        Call oWorkbook.Close(True)
        Set oWorkbook = Nothing
    End If
    'if excel has no more workbooks open then close
    If oExcel.Workbooks.count = 0 Then
        oExcel.Quit
    End If
    oExcel.Quit
End Sub


Private Function getWorksheet(strName As String, sheet As Excel.Worksheet) As String
    Dim e As Integer
    Dim count
    
    'Stepping to the worksheets
    For e = 1 To oWorkbook.Worksheets.count
        Set sheet = oWorkbook.Worksheets(e)
        If sheet.name = strName Then
            getWorksheet = ""
            Exit Function
        End If
    Next
    
    getWorksheet = "Worksheet " & strName & " not found"
End Function


Public Function createWorksheet(strName As String) As String
    If Not oWorkbook Is Nothing Then
        Dim e
        Dim testSheet As Excel.Worksheet
        Dim sheet As Excel.Worksheet
        
        'test if sheet allready exists
        For e = 1 To oWorkbook.Worksheets.count
            Set testSheet = oWorkbook.Worksheets(e)
            If testSheet.name = strName Then
                Set sheet = testSheet
                createWorksheet = ""
                Exit Function
            End If
        Next
        Set sheet = oWorkbook.Worksheets.Add()
        sheet.name = strName
        oWorkbook.Save
        createWorksheet = ""
    Else
        createWorksheet = "Creating workbook" & strName & "failed!"
    End If
End Function


Public Function setValue(iCol As Integer, iRow As Integer, strSheet As String, strVal As String) As String
    Dim sheet As Excel.Worksheet
    Dim strErr As String
    Dim rCol As Excel.Range
    Dim rRow As Excel.Range
    Dim rVal As Excel.Range
    
    On Error GoTo err_Handler
    
    'selecting the right sheet
    strErr = getWorksheet(strSheet, sheet)
    If Not strErr = "" Then
        Err.Raise 25, , strErr
    End If
    
    'getting the cell
    Set rVal = sheet.Cells(iRow, iCol)
    
    rVal.Value = strVal

Exit Function
    
    'error handling
err_Handler:

    setValue = "Error setValue(): " & Err.Description
       
End Function

Public Function setValueL(iCol As Integer, iRow As Long, strSheet As String, strVal As String) As String
    Dim sheet As Excel.Worksheet
    Dim strErr As String
    Dim rCol As Excel.Range
    Dim rRow As Excel.Range
    Dim rVal As Excel.Range
    
    On Error GoTo err_Handler
    
    'selecting the right sheet
    strErr = getWorksheet(strSheet, sheet)
    If Not strErr = "" Then
        Err.Raise 25, , strErr
    End If
    
    'getting the cell
    Set rVal = sheet.Cells(iRow, iCol)
    
    rVal.Value = strVal

Exit Function
    
    'error handling
err_Handler:

    setValueL = "Error setValue(): " & Err.Description
       
End Function






Function CoolLook(sheetName As String) As String

'Selecting the sheet
    oWorkbook.Sheets(sheetName).Select
    
'Make it look cool
    oWorkbook.ActiveSheet.Columns("A:A").Select
    Selection.ColumnWidth = 37
    oWorkbook.ActiveSheet.Columns("B:B").Select
    Selection.ColumnWidth = 17
    oWorkbook.ActiveSheet.Columns("C:C").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("D:D").Select
    Selection.ColumnWidth = 17
    oWorkbook.ActiveSheet.Columns("E:E").Select
    Selection.ColumnWidth = 40
    oWorkbook.ActiveSheet.Range("A1").Select
    Selection.AutoFilter
    oWorkbook.ActiveSheet.Range("A1:E1").Select
    Selection.Font.Bold = True
    oWorkbook.ActiveSheet.Range("A2").Select
    ActiveWindow.FreezePanes = True
    oWorkbook.ActiveSheet.Range("A1").Select



End Function


Function CoolLook2(sheetName As String) As String

'Selecting the sheet
    oWorkbook.Sheets(sheetName).Select
    
'Make it look cool
    oWorkbook.ActiveSheet.Columns("A:F").Select
    Selection.ColumnWidth = 25
    oWorkbook.ActiveSheet.Columns("B:B").Select
    Selection.ColumnWidth = 13
    oWorkbook.ActiveSheet.Columns("F:F").Select
    Selection.ColumnWidth = 17
    'Selection.NumberFormat = "mm/dd/yyyy h:mm;@"
    oWorkbook.ActiveSheet.Range("A1").Select
    Selection.AutoFilter
    oWorkbook.ActiveSheet.Range("A1:F1").Select
    Selection.Font.Bold = True
    oWorkbook.ActiveSheet.Range("A2").Select
    ActiveWindow.FreezePanes = True
    oWorkbook.ActiveSheet.Range("A1").Select

End Function

Function CoolLook3(sheetName As String) As String

'Selecting the sheet
    oWorkbook.Sheets(sheetName).Select
    
'Make it look cool
    oWorkbook.ActiveSheet.Columns("A:A").Select
    Selection.ColumnWidth = 20
    oWorkbook.ActiveSheet.Columns("B:B").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("C:C").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("D:D").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("E:E").Select
    Selection.ColumnWidth = 19
    oWorkbook.ActiveSheet.Columns("F:F").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("G:G").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("H:H").Select
    Selection.ColumnWidth = 15
    oWorkbook.ActiveSheet.Columns("I:I").Select
    Selection.ColumnWidth = 50
    oWorkbook.ActiveSheet.Range("A1").Select
    Selection.AutoFilter
    oWorkbook.ActiveSheet.Range("A1:I1").Select
    Selection.Font.Bold = True
    oWorkbook.ActiveSheet.Range("A2").Select
    ActiveWindow.FreezePanes = True
    oWorkbook.ActiveSheet.Range("A1").Select



End Function
Function CoolLook4(sheetName As String) As String

'Selecting the sheet
    oWorkbook.Sheets(sheetName).Select
    
'Make it look cool

    oWorkbook.ActiveSheet.Range("A1").Select
    Selection.AutoFilter
    oWorkbook.ActiveSheet.Range("A1:K1").Select
    Selection.Font.Bold = True
    oWorkbook.ActiveSheet.Range("A2").Select
    ActiveWindow.FreezePanes = True
    oWorkbook.ActiveSheet.Range("A1").Select



End Function


Function DOCU_GO_TO(link As String) As String

oWord.Selection.Goto What:=wdGoToBookmark, name:=link
           

End Function

Function DOCU_WRITE(text_ As String) As String

'Write stuff
oWord.Selection.TypeText Text:=text_
oWord.Selection.MoveRight Unit:=wdCell

End Function
Function DOCU_WRITE_(text_ As String) As String

'Write stuff

oWord.Selection.Font.Underline = wdUnderlineSingle
oWord.Selection.TypeText Text:=text_
oWord.Selection.Font.Underline = wdUnderlineNone

End Function

Function DOCU_DELETE_ROW() As String

oWord.Selection.Cells.Delete ShiftCells:=wdDeleteCellsEntireRow
oWord.Selection.MoveUp Unit:=wdLine, count:=1
'oWord.Selection.TypeText Text:="Proba"

End Function

Function DOCU_SORT() As String
    
    oWord.Selection.Sort ExcludeHeader:=True, FieldNumber:="Column 1", SortFieldType _
        :=wdSortFieldAlphanumeric, SortOrder:=wdSortOrderAscending, FieldNumber2 _
        :="Column 2", SortFieldType2:=wdSortFieldAlphanumeric, SortOrder2:= _
        wdSortOrderAscending, FieldNumber3:="", SortFieldType3:= _
        wdSortFieldAlphanumeric, SortOrder3:=wdSortOrderAscending, Separator:= _
        wdSortSeparateByCommas, SortColumn:=False, CaseSensitive:=False, _
        LanguageID:=wdEnglishCanadian, SubFieldNumber:="Paragraphs", _
        SubFieldNumber2:="Paragraphs", SubFieldNumber3:="Paragraphs"

End Function

Public Function extXls() As String

Dim appExcel As Object
Dim strXlVersion As String

Set appExcel = CreateObject("Excel.Application")
strXlVersion = appExcel.Version
appExcel.Quit
Set appExcel = Nothing

If Int(Left(strXlVersion, InStr(strXlVersion, "."))) >= 12 Then
    extXls = ".xlsx"
Else: extXls = ".xls"
End If


End Function

Public Function extWrd() As String

Dim appWd As Object
Dim strWdVersion As String

Set appWd = CreateObject("Word.Application")
strWdVersion = appWd.Version
appWd.Quit
Set appWd = Nothing

If Int(Left(strWdVersion, InStr(strWdVersion, "."))) >= 12 Then
    extWrd = ".docx"
Else: extWrd = ".doc"
End If


End Function
