Attribute VB_Name = "modMSTR"

Option Explicit
Option Private Module


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+ Get the dependent objects
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Public Function getDependenciesForObject(objObject As IDSSObjectInfo2) As IDSSFolder
    Dim objsearch As IDSSSearch
    Dim ObjFolder As IDSSFolder
    
    '++ Create new search object
    Set objsearch = objSession.ObjectSource.NewObject(DssTypeSearch)
    objsearch.Clear
    '++ Add object as specified by parameter
    Call objsearch.Uses.Add(objObject)
    objsearch.Flags = DssSearchUsesOneOf
    '++ Execute the search and store the result set in objFolder
    Set ObjFolder = objsearch.Execute
    
    '++ the return value is the collection of dependents
    Set getDependenciesForObject = ObjFolder
    
    '++ Clean UP!
    Set objsearch = Nothing
End Function


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+ Get the recurrent dependent objects
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Public Function getRecDependenciesForObject(objObject As IDSSObjectInfo2) As IDSSFolder
    Dim objsearch As IDSSSearch
    Dim ObjFolder As IDSSFolder
    
    '++ Create new search object
    Set objsearch = objSession.ObjectSource.NewObject(DssTypeSearch)
    objsearch.Clear
    '++ Add object as specified by parameter
    Call objsearch.Uses.Add(objObject)
    objsearch.Flags = DssSearchUsesRecursive
    '++ Execute the search and store the result set in objFolder
    Set ObjFolder = objsearch.Execute
    
    '++ the return value is the collection of dependents
    Set getRecDependenciesForObject = ObjFolder
    
    '++ Clean UP!
    Set objsearch = Nothing
End Function


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+ Convert the subType into plain English
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Public Function DSS2Name(numSubType As Integer) As String

Select Case numSubType
    Case 256
        DSS2Name = "Filter"
    Case 257
        DSS2Name = "Custom Group"
    Case 512
        DSS2Name = "Template"
    Case 768
        DSS2Name = "Grid"
    Case 769
        DSS2Name = "Graph"
    Case 770
        DSS2Name = "SQL"
    Case 774
        DSS2Name = "Grid Graph"
    Case 776
        DSS2Name = "Intelligent Cube"
    Case 1024
        DSS2Name = "Metric"
    Case 1025
        DSS2Name = "Subtotal"
    Case 1026
        DSS2Name = "Function"
    Case 1027
        DSS2Name = "Predictive Metric"
    Case 1536
        DSS2Name = "Autostyle"
    Case 1792
        DSS2Name = "Base Formula"
    Case 2048
        DSS2Name = "Folder"
    Case 2049
        DSS2Name = "Folder"
    Case 2304
        DSS2Name = "Device"
    Case 2563
        DSS2Name = "Text Prompt"
    Case 2564
        DSS2Name = "Numeric Prompt"
    Case 2565
        DSS2Name = "Date Prompt"
    Case 2566
        DSS2Name = "Object Prompt"
    Case 2567
        DSS2Name = "Elements Prompt"
    Case 2568
        DSS2Name = "Expression Prompt"
    Case 2816
        DSS2Name = "Function"
    Case 3072
        DSS2Name = "Attribute"
    Case 3074
        DSS2Name = "Transformation"
    Case 3328
        DSS2Name = "Fact"
    Case 3584
        DSS2Name = "Hierarchy"
    Case 3585
        DSS2Name = "Hierarchy"
    Case 3587
        DSS2Name = "Hierarchy"
    Case 3840
        DSS2Name = "Logical Table"
    Case 3842
        DSS2Name = "Warehouse Partition Mapping"
    Case 4608
        DSS2Name = "Shortcut"
    Case 5377
        DSS2Name = "Attribute Element"
    Case 5378
        DSS2Name = "Attribute Element"
    Case 5632
        DSS2Name = "Schema"
    Case 5888
        DSS2Name = "Schema"
    Case 6144
        DSS2Name = "Catalog"
    Case 6400
        DSS2Name = "Catalog Definition"
    Case 6656
        DSS2Name = "Column"
    Case 7168
        DSS2Name = "Property Set"
    Case 7424
        DSS2Name = "Database Instance"
    Case 7680
        DSS2Name = "Database Login"
    Case 7936
        DSS2Name = "Database Connection"
    Case 8192
        DSS2Name = "Project"
    Case 8448
        DSS2Name = "Project Source"
    Case 8704
        DSS2Name = "User"
    Case 8705
        DSS2Name = "User Group"
    Case 8960
        DSS2Name = "Transmitter"
    Case 9216
        DSS2Name = "Configuration"
    Case 9472
        DSS2Name = "Request"
    Case 9984
        DSS2Name = "Search"
    Case 10752
        DSS2Name = "Function Definition"
    Case 11009
        DSS2Name = "Transformation"
    Case 11264
        DSS2Name = "Security Role"
    Case 11520
        DSS2Name = "Language"
    Case 12032
        DSS2Name = "Consolidation"
    Case 12288
        DSS2Name = "Derived Element"
    Case 12544
        DSS2Name = "Event"
    Case 13056
        DSS2Name = "Schedule"
    Case 13312
        DSS2Name = "Link"
    Case 13568
        DSS2Name = "Logical Table"
    Case 13569
        DSS2Name = "Logical Table"
    Case 14080
        DSS2Name = "HTML Document"
    Case 14081
        DSS2Name = "Document"
    Case 14336
        DSS2Name = "Drill Map"
    Case 14592
        DSS2Name = "DBMS"
    Case 14848
        DSS2Name = "Security Filter"
    Case 15360
        DSS2Name = "Prompt Answer"
    Case 15616
        DSS2Name = "Graph Element"
    Case 772
        DSS2Name = "Data Mart Report"
    Case 775
        DSS2Name = "Non Interactive"
    Case Else
        DSS2Name = Str(numSubType)
End Select


End Function


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+ Convert the subType into plain English (simplified)
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Public Function DSS2NameSimple(numSubType As Integer) As String

Select Case numSubType
    Case 256
        DSS2NameSimple = "Filter"
    Case 257
        DSS2NameSimple = "Custom Group"
    Case 512
        DSS2NameSimple = "Template"
    Case 768
        DSS2NameSimple = "Report"
    Case 769
        DSS2NameSimple = "Report"
    Case 770
        DSS2NameSimple = "Report"
    Case 774
        DSS2NameSimple = "Report"
    Case 776
        DSS2NameSimple = "Intelligent Cube"
    Case 1024
        DSS2NameSimple = "Metric"
    Case 1025
        DSS2NameSimple = "Subtotal"
    Case 1026
        DSS2NameSimple = "Function"
    Case 1027
        DSS2NameSimple = "Metric"
    Case 1536
        DSS2NameSimple = "Autostyle"
    Case 1792
        DSS2NameSimple = "Base Formula"
    Case 2048
        DSS2NameSimple = "Folder"
    Case 2049
        DSS2NameSimple = "Folder"
    Case 2304
        DSS2NameSimple = "Device"
    Case 2563
        DSS2NameSimple = "Prompt"
    Case 2564
        DSS2NameSimple = "Prompt"
    Case 2565
        DSS2NameSimple = "Prompt"
    Case 2566
        DSS2NameSimple = "Prompt"
    Case 2567
        DSS2NameSimple = "Prompt"
    Case 2568
        DSS2NameSimple = "Prompt"
    Case 2816
        DSS2NameSimple = "Function"
    Case 3072
        DSS2NameSimple = "Attribute"
    Case 3074
        DSS2NameSimple = "Transformation"
    Case 3328
        DSS2NameSimple = "Fact"
    Case 3584
        DSS2NameSimple = "Hierarchy"
    Case 3585
        DSS2NameSimple = "Hierarchy"
    Case 3587
        DSS2NameSimple = "Hierarchy"
    Case 3840
        DSS2NameSimple = "Table"
    Case 3842
        DSS2NameSimple = "Warehouse Partition Mapping"
    Case 4608
        DSS2NameSimple = "Shortcut"
    Case 5377
        DSS2NameSimple = "Attribute Element"
    Case 5378
        DSS2NameSimple = "Attribute Element"
    Case 5632
        DSS2NameSimple = "Schema"
    Case 5888
        DSS2NameSimple = "Schema"
    Case 6144
        DSS2NameSimple = "Catalog"
    Case 6400
        DSS2NameSimple = "Catalog Definition"
    Case 6656
        DSS2NameSimple = "Column"
    Case 7168
        DSS2NameSimple = "Property Set"
    Case 7424
        DSS2NameSimple = "Database Instance"
    Case 7680
        DSS2NameSimple = "Database Login"
    Case 7936
        DSS2NameSimple = "Database Connection"
    Case 8192
        DSS2NameSimple = "Project"
    Case 8448
        DSS2NameSimple = "Project Source"
    Case 8704
        DSS2NameSimple = "User"
    Case 8705
        DSS2NameSimple = "User Group"
    Case 8960
        DSS2NameSimple = "Transmitter"
    Case 9216
        DSS2NameSimple = "Configuration"
    Case 9472
        DSS2NameSimple = "Request"
    Case 9984
        DSS2NameSimple = "Search"
    Case 10752
        DSS2NameSimple = "Function Definition"
    Case 11009
        DSS2NameSimple = "Transformation"
    Case 11264
        DSS2NameSimple = "Security Role"
    Case 11520
        DSS2NameSimple = "Language"
    Case 12032
        DSS2NameSimple = "Consolidation"
    Case 12288
        DSS2NameSimple = "Derived Element"
    Case 12544
        DSS2NameSimple = "Event"
    Case 13056
        DSS2NameSimple = "Schedule"
    Case 13312
        DSS2NameSimple = "Link"
    Case 13568
        DSS2NameSimple = "Table"
    Case 13569
        DSS2NameSimple = "Table"
    Case 14080
        DSS2NameSimple = "HTML Document"
    Case 14081
        DSS2NameSimple = "Document"
    Case 14336
        DSS2NameSimple = "Drill Map"
    Case 14592
        DSS2NameSimple = "DBMS"
    Case 14848
        DSS2NameSimple = "Security Filter"
    Case 15360
        DSS2NameSimple = "Prompt Answer"
    Case 15616
        DSS2NameSimple = "Graph Element"
    Case 772
        DSS2NameSimple = "Data Mart Report"
    Case 775
        DSS2NameSimple = "Non Interactive"
    Case Else
        DSS2NameSimple = Str(numSubType)
End Select


End Function


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+ Convert the English type of an object into its generic icon name
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Public Function Name2Ico(name As String) As String

Select Case name
    Case "Request"
        Name2Ico = "Other"
    Case "Link"
        Name2Ico = "Other"
    Case "Schedule"
        Name2Ico = "Other"
    Case "Event"
        Name2Ico = "Other"
    Case "Configuration"
        Name2Ico = "Other"
    Case "Property Set"
        Name2Ico = "Other"
    Case "Column"
        Name2Ico = "Other"
    Case "Catalog"
        Name2Ico = "Other"
    Case "Catalog Definition"
        Name2Ico = "Other"
    Case "Schema"
        Name2Ico = "Other"
    Case "Prompt Answer"
        Name2Ico = "Prompt"
    Case "Column"
        Name2Ico = "Other"
    Case "Function Definition"
        Name2Ico = "Function"
    Case "Prompt Answer"
        Name2Ico = "Prompt"
    Case "Text Prompt"
        Name2Ico = "Prompt"
    Case "Numeric Prompt"
        Name2Ico = "Prompt"
    Case "Date Prompt"
        Name2Ico = "Prompt"
    Case "Object Prompt"
        Name2Ico = "Prompt"
    Case "Elements"
        Name2Ico = "Prompt"
    Case "Elements Prompt"
        Name2Ico = "Prompt"
    Case "Expression Prompt"
        Name2Ico = "Prompt"
    Case "Data Mart Report"
        Name2Ico = "Grid"
    Case "Non Interactive"
        Name2Ico = "Grid"
    Case Else
        Name2Ico = name
End Select

If Left(name, 1) = " " Then
    Name2Ico = "Other"
End If

End Function


Public Function getMetricCond(objCond As IDSSConditionality) As String
    If Not objCond.Filter Is Nothing Then
        getMetricCond = objCond.Filter.Info.name
        getMetricCond = getMetricCond & " (" & objCond.Filter.Expression.TextEx(7) & ")"
    End If
End Function

Public Function getMetricDim(objDim As IDSSDimty) As String
    Dim i As Integer
    Dim test As Boolean
    test = False
    
    For i = 1 To objDim.count
        Select Case objDim.Item(i).UnitType
            Case Is = DssDimtyUnitTypeReportBaseLevel
                If test = True Then
                    getMetricDim = getMetricDim & " || "
                End If
                getMetricDim = getMetricDim & "Report Level: ("
                getMetricDim = getMetricDim & formatFiltering(objDim.Item(i).Filtering) & " - "
                getMetricDim = getMetricDim & formatAggregation(objDim.Item(i).Aggregation, objDim.Item(i).GroupBy) & ")"
                test = True
            Case Is = DssDimtyUnitTypeRole
            Case Else
                If test = True Then
                    getMetricDim = getMetricDim & " || "
                End If
                'MsgBox objDim.Info.name
                On Error Resume Next
                getMetricDim = getMetricDim & objDim.Item(i).Target.name & ": ("
                getMetricDim = getMetricDim & objDim.Item(i).TargetPrompt.Info.name & " (prompt) : ("
                getMetricDim = getMetricDim & formatFiltering(objDim.Item(i).Filtering) & " - "
                getMetricDim = getMetricDim & formatAggregation(objDim.Item(i).Aggregation, objDim.Item(i).GroupBy) & ")"
                test = True
        End Select
    Next
End Function

Public Function getMetricTrans(objDim As IDSSDimty) As String
    Dim i As Integer
    Dim test As Boolean
    test = False
    
    For i = 1 To objDim.count
        If objDim.Item(i).UnitType = DssDimtyUnitTypeRole Then
            If test = True Then
                getMetricTrans = getMetricTrans & " || "
            End If
            getMetricTrans = getMetricTrans & objDim.Item(i).Role.Info.name
            test = True
        End If
    Next
End Function


Public Function formatFiltering(eFilterLevel As EnumDSSFiltering) As String
    Select Case eFilterLevel
        Case Is = DssFilteringAbsolute
            formatFiltering = "Absolute"
        Case Is = DssFilteringApply
            formatFiltering = "Standard"
        Case Is = DssFilteringIgnore
            formatFiltering = "Ignore"
        Case Is = DssFilteringNone
            formatFiltering = "None"
    End Select
End Function

Public Function formatAggregation(eAggLevel As EnumDSSAggregation, bolGroupBy As Boolean) As String
    Select Case eAggLevel
        Case Is = DssAggregationFirstInFact
            formatAggregation = "Beginning (fact)"
        Case Is = DssAggregationFirstInRelationship
            formatAggregation = "Beginning (lookup)"
        Case Is = DssAggregationLastInFact
            formatAggregation = "Ending (fact)"
        Case Is = DssAggregationLastInRelationship
            formatAggregation = "Ending (lookup)"
        Case Is = DssAggregationNormal
            If bolGroupBy = True Then
                formatAggregation = "Standard"
            Else
                formatAggregation = "None"
            End If
    End Select
End Function

Public Function JournalTransaction(name As String) As String


Select Case name
    Case "1"
        JournalTransaction = "Enable Change Journal"
    Case "2"
        JournalTransaction = "Disable Change Journal"
    Case "3"
        JournalTransaction = "Purge Change Journal"
    Case "4"
        JournalTransaction = "Save"
    Case "5"
        JournalTransaction = "Save"
    Case "6"
        JournalTransaction = "Save Link Items"
    Case "7"
        JournalTransaction = "Delete"
    Case "8"
        JournalTransaction = "Delete"
    Case "9"
        JournalTransaction = "Copy"
    Case "10"
        JournalTransaction = "Merge User"
    Case "11"
        JournalTransaction = "Collect Garbage"
    Case "12"
        JournalTransaction = "Write System Property"
    Case "13"
        JournalTransaction = "Write Database Password"
    Case Else
        JournalTransaction = "Other"
End Select


End Function

Public Function JournalChange(name As String) As String


Select Case name
    Case "1"
        JournalChange = "Create"
    Case "2"
        JournalChange = "Change"
    Case "3"
        JournalChange = "Delete"
    Case "4"
        JournalChange = "Touch Folder"
    Case "5"
        JournalChange = "Create Link Item"
    Case "6"
        JournalChange = "Change Link Item"
    Case "7"
        JournalChange = "Delete Link Item"
    Case "8"
        JournalChange = "Change Journal Enable"
    Case "9"
        JournalChange = "Change Journal Disable"
    Case "10"
        JournalChange = "Change Journal Purge"
    Case Else
        JournalChange = "Other"
End Select


End Function

